@echo off 
color 74

:: BatchGotAdmin
:-------------------------------------
REM  --> Check for permissions
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"=""
    echo UAC.ShellExecute "cmd.exe", "/c %~s0 %params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    pushd "%CD%"
    CD /D "%~dp0"
:--------------------------------------

::AC BK

echo Running BioStar 2 AC Database Backup....

cd /D "UserDrive:\Program Files\BioStar 2\ta\mariadb-10.1.10-win32\bin"

mysqldump -u UserID --password=UserPW -P 3312 --routines --triggers --max_allowed_packet=1G --hex-blob --default-character-set=utf8 --add-drop-database biostar2_ac  > ACbackup.sql
CALL :CHECK_FAIL

echo AC Database Backup complete!

::TA BK

echo Running BioStar 2 TA Database Backup....

cd /D "UserDrive:\Program Files\BioStar 2\ta\mariadb-10.1.10-win32\bin"


mysqldump -u UserID --password=UserPW -P 3312 --routines --triggers --max_allowed_packet=1G --hex-blob --default-character-set=utf8 --add-drop-database biostar_tna  > TAbackup.sql
CALL :CHECK_FAIL

echo TA Database Backup complete!

::VE BK

echo Running BioStar 2 VE Database Backup....

cd /D "UserDrive:\Program Files\BioStar 2\ta\mariadb-10.1.10-win32\bin"


mysqldump -u UserID --password=UserPW -P 3312 --routines --triggers --max_allowed_packet=1G --hex-blob --default-character-set=utf8 --add-drop-database biostar_ve  > VEbackup.sql
CALL :CHECK_FAIL

echo VE Database Backup complete!

:EVERYTHINGELSE

echo Now renaming previous Backup(s)
echo.

RD /S /Q "WHERE\Backup10"
move "WHERE\Backup9" "WHERE\Backup10"
move "WHERE\Backup8" "WHERE\Backup9"
move "WHERE\Backup7" "WHERE\Backup8"
move "WHERE\Backup6" "WHERE\Backup7"
move "WHERE\Backup5" "WHERE\Backup6"
move "WHERE\Backup4" "WHERE\Backup5"
move "WHERE\Backup3" "WHERE\Backup4"
move "WHERE\Backup2" "WHERE\Backup3"
move "WHERE" "WHERE\Backup2"

echo Now copying Non-Database files
echo.

Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2\ta\security" "WHERE\security"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2\cert" "WHERE\cert"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2\imagelog" "WHERE\imagelog"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2\ve\records" "WHERE\ve\records"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2\ve\db" "WHERE\ve\db"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2\nginx\html\upload" "WHERE\upload"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2\lic" "WHERE\lic"
xcopy /y "UserDrive:\Program Files\BioStar 2\nginx\conf\biostar_cert.crt" "WHERE\conf\"
xcopy /y "UserDrive:\Program Files\BioStar 2\nginx\conf\biostar_cert.key" "WHERE\conf\"
xcopy /y "UserDrive:\Program Files\BioStar 2\nginx\conf\biostar_cert.p12" "WHERE\conf\"
xcopy /y "UserDrive:\Program Files\BioStar 2\nginx\conf\keystore.jks" "WHERE\conf\"
copy /y "UserDrive:\Program Files\BioStar 2\setting.conf" "WHERE\"
copy /y "UserDrive:\Program Files\BioStar 2\system.conf" "WHERE\"
copy /y "KEYENC" "WHERE\"

echo.
echo Non-Database files Copied

:EncLocation
set ENCKEY="KEYENC"
DEL /F "WHERE\enckeyloc.txt"
echo %enckey% >> "WHERE\enckeyloc.txt"

:MOVE

Echo Moving Files...

md "WHERE\" 2> nul

move /y "UserDrive:\Program Files\BioStar 2\ta\mariadb-10.1.10-win32\bin\ACbackup.sql" "WHERE\"

move /y "UserDrive:\Program Files\BioStar 2\ta\mariadb-10.1.10-win32\bin\TAbackup.sql" "WHERE\"

move /y "UserDrive:\Program Files\BioStar 2\ta\mariadb-10.1.10-win32\bin\VEbackup.sql" "WHERE\"

Echo All Done!
timeout 6
goto END

:CHECK_FAIL
@echo off
IF %ERRORLEVEL% NEQ 0 (
echo.
Echo Wrong User or Password Detected
pause
EXIT
) 


:END
endlocal
