@echo off
color 74

:: BatchGotAdmin
:-------------------------------------
REM  --> Check for permissions
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"=""
    echo UAC.ShellExecute "cmd.exe", "/c %~s0 %params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    pushd "%CD%"
    CD /D "%~dp0"

:--------------------------------------

echo.
echo     _____ __  ______  ____  ________  ______ 
echo    / ___// / / / __ \/ __ \/ ____/  ^|/  /   ^|
echo    \__ \/ / / / /_/ / /_/ / __/ / /^|_/ / /^| ^|
echo   ___/ / /_/ / ____/ _, _/ /___/ /  / / ___ ^|
echo  /____/\____/_/   /_/ ^|_/_____/_/  /_/_/  ^|_^|
echo.       
echo ===============================================
echo            BioStar 2.8.12 DB Restore
echo ===============================================
echo.
echo.
echo ===============================================
echo  THIS TOOL IS ONLY TESTED WITH 2.7.10 - 2.8.12
echo ===============================================
echo   ONLY SUPPORTED FOR USE WITH 2.7.10 - 2.8.12
echo ===============================================
echo.


:LOCATION
echo Please enter location of folder containing the restore files. E.g (C:\Backup) 
echo.
echo (C:\ on its own cannot be used.)
echo. 
set /P RESTOREFOLDER=
If /I "%RESTOREFOLDER%"=="C" GOTO END
If /I "%RESTOREFOLDER%"=="C:" GOTO END
If /I "%RESTOREFOLDER%"=="C:\" GOTO END
echo.

:PROMPT
SET AREYOUSURE=N
echo This restore utility should only be used on a new install of BioStar 2, not one with pre-existing data, 
echo.otherwise you may lose EVERYTHING, are you sure you want to continue?
echo.
echo.This restore utility should also only be used with files generated by the Auto Backup utility.
echo.

set /P AREYOUSURE=Are you sure (Y/[N])?
if /I "%AREYOUSURE%" NEQ "Y" GOTO END
echo.

:bit
echo Enter your BioStar bit architecture 
echo 1. 32bit (32 Architecture) (Enter 1 or 3232) 
echo 2. 32bit (64 Architecture) (Enter 2 or 3264)
echo 3. 64bit (64 Architecture) (Enter 3 or 64)
echo.
set /P BIT=
%=%
If /I "%BIT%"=="1" goto cont
If /I "%BIT%"=="2" goto cont
If /I "%BIT%"=="3" goto cont
If /I "%BIT%"=="3232" goto cont
If /I "%BIT%"=="3264" goto cont
If /I "%BIT%"=="64" goto cont

echo.
echo Incorrect input & goto :bit
echo. 

:cont

echo.
echo Type in the drive letter you installed BioStar 2 (example: c)
set /p UserDrive=
echo.

CALL :SETUSERPASS

:bitcheck

If /I "%BIT%"=="1" goto 3232RESTORE
If /I "%BIT%"=="2" goto 32RESTORE
If /I "%BIT%"=="3" goto 64RESTORE
If /I "%BIT%"=="3232" goto 32RESTORE
If /I "%BIT%"=="3264" goto 32RESTORE
If /I "%BIT%"=="64" goto 64RESTORE

:3232RESTORE

echo Services Stopping
sc stop "BioStar 2 TA Web Server"
sc stop "BioStar 2 Web Server"
sc stop "BioStar 2 Video Web Server"
echo.

echo Making sure the DB is running
echo.
sc start "BioStar 2 Launcher"
echo.

cd /D %UserDrive%:\Program Files\BioStar 2\ta\mariadb-10.1.10-win32\bin

echo Restore Beginning.
echo.

echo Dropping Existing AC Database
echo.
:RETRYDROP3232

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar2_ac -e "DROP DATABASE biostar2_ac"

IF %ERRORLEVEL% NEQ 0 (
echo.
Echo Wrong User or Password Detected
echo.
CALL :SETUSERPASS
GOTO RETRYDROP3232
) 


mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar2_ac"

echo Dropped biostar2_ac
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar2_ac < "%RESTOREFOLDER%\ACbackup.sql"
echo AC Database Restored
echo.

echo Dropping Existing TNA Database
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar_tna -e "DROP DATABASE biostar_tna"
mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar_tna"

echo Dropped biostar_tna
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar_tna < "%RESTOREFOLDER%\TAbackup.sql"
echo TNA Database Restored
echo.

echo Dropping Existing VE Database
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar_ve -e "DROP DATABASE biostar_ve"
mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar_ve"

echo Dropped biostar_ve
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar_ve < "%RESTOREFOLDER%\VEbackup.sql"
echo VE Database Restored
echo.

echo Stopping DB Service
echo.
sc stop "BioStar 2 Launcher"
sc stop "BioStar 2 MariaDB"

Xcopy /E /I /Y "%RESTOREFOLDER%\security" "%UserDrive%:\Program Files\BioStar 2\ta\security"
Xcopy /E /I /Y "%RESTOREFOLDER%\cert" "%UserDrive%:\Program Files\BioStar 2\cert" 
Xcopy /E /I /Y "%RESTOREFOLDER%\imagelog" "%UserDrive%:\Program Files\BioStar 2\imagelog" 
Xcopy /E /I /Y "%RESTOREFOLDER%\ve\records" "%UserDrive%:\Program Files\BioStar 2\ve\records" 
Xcopy /E /I /Y "%RESTOREFOLDER%\ve\db" "%UserDrive%:\Program Files\BioStar 2\ve\db" 
Xcopy /E /I /Y "%RESTOREFOLDER%\upload" "%UserDrive%:\Program Files\BioStar 2\nginx\html\upload" 
Xcopy /E /I /Y "%RESTOREFOLDER%\lic" "%UserDrive%:\Program Files\BioStar 2\lic"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.crt" "%UserDrive%:\Program Files\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.key" "%UserDrive%:\Program Files\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.p12" "%UserDrive%:\Program Files\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\keystore.jks" "%UserDrive%:\Program Files\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\setting.conf" "%UserDrive%:\Program Files\BioStar 2\" 
copy /y "%RESTOREFOLDER%\system.conf" "%UserDrive%:\Program Files\BioStar 2\" 

set /p enckeyloc=<"%RESTOREFOLDER%\enckeyloc.txt"
copy /y "%RESTOREFOLDER%\enckey" %ENCKEYLOC% 


echo Services Starting
sc start "BioStar 2 Launcher"
sc start "BioStar 2 TA Web Server"
sc start "BioStar 2 Web Server"
sc start "BioStar 2 Video Web Server"
echo.

echo Restore Completed!
echo.

timeout 6

GOTO END

:32RESTORE

echo Services Stopping
sc stop "BioStar 2 TA Web Server"
sc stop "BioStar 2 Web Server"
sc stop "BioStar 2 Video Web Server"
echo.

echo Making sure the DB is running
echo.
sc start "BioStar 2 Launcher"
echo.

cd /D %UserDrive%:\Program Files (x86)\BioStar 2\ta\mariadb-10.1.10-win32\bin

echo Restore Beginning.
echo.

echo Dropping Existing AC Database
echo.

:RETRYDROP32

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar2_ac -e "DROP DATABASE biostar2_ac"

IF %ERRORLEVEL% NEQ 0 (
echo.
Echo Wrong User or Password Detected
echo.
CALL :SETUSERPASS
GOTO RETRYDROP32
) 

mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar2_ac"

echo Dropped biostar2_ac
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar2_ac < "%RESTOREFOLDER%\ACbackup.sql"
echo AC Database Restored
echo.

echo Dropping Existing TNA Database
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar_tna -e "DROP DATABASE biostar_tna"
mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar_tna"

echo Dropped biostar_tna
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar_tna < "%RESTOREFOLDER%\TAbackup.sql"
echo TNA Database Restored
echo.

echo Dropping Existing VE Database
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar_ve -e "DROP DATABASE biostar_ve"
mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar_ve"

echo Dropped biostar_ve
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar_ve < "%RESTOREFOLDER%\VEbackup.sql"
echo VE Database Restored
echo.


echo Stopping DB Service
echo.
sc stop "BioStar 2 Launcher"
sc stop "BioStar 2 MariaDB"

Xcopy /E /I /Y "%RESTOREFOLDER%\security" "%UserDrive%:\Program Files(x86)\BioStar 2(x64)\ta\security"
Xcopy /E /I /Y "%RESTOREFOLDER%\cert" "%UserDrive%:\Program Files(x86)\BioStar 2\cert" 
Xcopy /E /I /Y "%RESTOREFOLDER%\imagelog" "%UserDrive%:\Program Files(x86)\BioStar 2\imagelog" 
Xcopy /E /I /Y "%RESTOREFOLDER%\ve\records" "%UserDrive%:\Program Files(x86)\BioStar 2\ve\records" 
Xcopy /E /I /Y "%RESTOREFOLDER%\ve\db" "%UserDrive%:\Program Files(x86)\BioStar 2\ve\db" 
Xcopy /E /I /Y "%RESTOREFOLDER%\upload" "%UserDrive%:\Program Files(x86)\BioStar 2\nginx\html\upload" 
Xcopy /E /I /Y "%RESTOREFOLDER%\lic" "%UserDrive%:\Program Files(x86)\BioStar 2(x64)\lic"

copy /y "%RESTOREFOLDER%\conf\biostar_cert.crt" "%UserDrive%:\Program Files(x86)\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.key" "%UserDrive%:\Program Files(x86)\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.p12" "%UserDrive%:\Program Files(x86)\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\keystore.jks" "%UserDrive%:\Program Files(x86)\BioStar 2\nginx\conf\"
copy /y "%RESTOREFOLDER%\setting.conf" "%UserDrive%:\Program Files(x86)\BioStar 2\" 
copy /y "%RESTOREFOLDER%\system.conf" "%UserDrive%:\Program Files(x86)\BioStar 2\" 

set /p enckeyloc=<"%RESTOREFOLDER%\enckeyloc.txt"
copy /y "%RESTOREFOLDER%\enckey" %ENCKEYLOC% 


echo Services Starting
sc start "BioStar 2 Launcher"
sc start "BioStar 2 TA Web Server"
sc start "BioStar 2 Web Server"
sc start "BioStar 2 Video Web Server"
echo.

echo Restore Completed!
echo.

timeout 6

GOTO END

:64RESTORE

echo Services Stopping
sc stop "BioStar 2 TA Web Server(x64)"
sc stop "BioStar 2 Web Server(x64)"
sc stop "BioStar 2 Video Web Server(x64)"
echo.

echo Making sure the DB is running
echo.
sc start "BioStar 2 Launcher(x64)"
echo.

cd /D %UserDrive%:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin

echo Restore Beginning.
echo.

echo Dropping Existing AC Database
echo.

:RETRYDROP64

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar2_ac -e "DROP DATABASE biostar2_ac"

IF %ERRORLEVEL% NEQ 0 (
echo.
Echo Wrong User or Password Detected
echo.
CALL :SETUSERPASS
GOTO RETRYDROP64
) 

mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar2_ac"

echo Dropped biostar2_ac
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar2_ac < "%RESTOREFOLDER%\ACbackup.sql"
echo AC Database Restored
echo.

echo Dropping Existing TNA Database
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar_tna -e "DROP DATABASE biostar_tna"
mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar_tna"

echo Dropped biostar_tna
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar_tna < "%RESTOREFOLDER%\TAbackup.sql"
echo TNA Database Restored
echo.

echo Dropping Existing VE Database
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 -D biostar_ve -e "DROP DATABASE biostar_ve"
mysql -u %UserID% --password=%UserPW% -P 3312 -e "CREATE DATABASE biostar_ve"

echo Dropped biostar_ve
echo.

mysql -u %UserID% --password=%UserPW% -P 3312 biostar_ve < "%RESTOREFOLDER%\VEbackup.sql"
echo VE Database Restored
echo.

Xcopy /E /I /Y "%RESTOREFOLDER%\security" "%UserDrive%:\Program Files\BioStar 2(x64)\ta\security"
Xcopy /E /I /Y "%RESTOREFOLDER%\cert" "%UserDrive%:\Program Files\BioStar 2(x64)\cert" 
Xcopy /E /I /Y "%RESTOREFOLDER%\imagelog" "%UserDrive%:\Program Files\BioStar 2(x64)\imagelog" 
Xcopy /E /I /Y "%RESTOREFOLDER%\ve\records" "%UserDrive%:\Program Files\BioStar 2(x64)\ve\records" 
Xcopy /E /I /Y "%RESTOREFOLDER%\ve\db" "%UserDrive%:\Program Files\BioStar 2(x64)\ve\db" 
Xcopy /E /I /Y "%RESTOREFOLDER%\upload" "%UserDrive%:\Program Files\BioStar 2(x64)\nginx\html\upload" 
Xcopy /E /I /Y "%RESTOREFOLDER%\lic" "%UserDrive%:\Program Files\BioStar 2(x64)\lic"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.crt" "%UserDrive%:\Program Files\BioStar 2(x64)\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.key" "%UserDrive%:\Program Files\BioStar 2(x64)\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\biostar_cert.p12" "%UserDrive%:\Program Files\BioStar 2(x64)\nginx\conf\"
copy /y "%RESTOREFOLDER%\conf\keystore.jks" "%UserDrive%:\Program Files\BioStar 2(x64)\nginx\conf\"
copy /y "%RESTOREFOLDER%\setting.conf" "%UserDrive%:\Program Files\BioStar 2(x64)\" 
copy /y "%RESTOREFOLDER%\system.conf" "%UserDrive%:\Program Files\BioStar 2(x64)\" 
set /p enckeyloc=<"%RESTOREFOLDER%\enckeyloc.txt"
copy /y "%RESTOREFOLDER%\enckey" %ENCKEYLOC% 

timeout 6

echo Services Starting

sc start "BioStar 2 Launcher(x64)"
sc start "BioStar 2 TA Web Server(x64)"
sc start "BioStar 2 Web Server(x64)"
sc start "BioStar 2 Video Web Server(x64)"

echo.
echo Restore Completed!
echo.

timeout 6

GOTO END

:SETUSERPASS
@echo off
echo Please enter Database ID (Usually root):
set /P UserID=
echo.
powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

:END
endlocal
