@echo off 
color 74

:: BatchGotAdmin
:-------------------------------------
REM  --> Check for permissions
>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"

REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"=""
    echo UAC.ShellExecute "cmd.exe", "/c %~s0 %params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    pushd "%CD%"
    CD /D "%~dp0"
:--------------------------------------

::AC BK

echo Running BioStar 2 AC Database Backup....

cd /d "UserDrive:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin"

mysqldump -u UserID --password=UserPW -P 3312 --routines --triggers --max_allowed_packet=1G --hex-blob --default-character-set=utf8 --add-drop-database biostar2_ac  > ACbackup.sql
CALL :CHECK_FAIL
echo AC Database Backup complete!

::TA BK

echo Running BioStar 2 TA Database Backup....

cd /d "UserDrive:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin"
 
mysqldump -u UserID --password=UserPW -P 3312 --routines --triggers --max_allowed_packet=1G --hex-blob --default-character-set=utf8 --add-drop-database biostar_tna  > TAbackup.sql
CALL :CHECK_FAIL
echo TA Database Backup complete!

::VE BK

echo Running BioStar 2 VE Database Backup....

cd /d "UserDrive:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin"

mysqldump -u UserID --password=UserPW -P 3312 --routines --triggers --max_allowed_packet=1G --hex-blob --default-character-set=utf8 --add-drop-database biostar_ve  > VEbackup.sql
CALL :CHECK_FAIL
echo VE Database Backup complete!

:EVERYTHINGELSE

echo Now renaming previous Backup(s)
echo.

RD /S /Q "WHERE_10"
move "WHERE_9" "WHERE_10"
move "WHERE_8" "WHERE_9"
move "WHERE_7" "WHERE_8"
move "WHERE_6" "WHERE_7"
move "WHERE_5" "WHERE_6"
move "WHERE_4" "WHERE_5"
move "WHERE_3" "WHERE_4"
move "WHERE_2" "WHERE_3"
move "WHERE" "WHERE_2"

echo Now copying Non-Database files
echo.

Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2(x64)\ta\security" "WHERE\security"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2(x64)\cert" "WHERE\cert"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2(x64)\imagelog" "WHERE\imagelog"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2(x64)\ve\records" "WHERE\ve\records"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2(x64)\ve\db" "WHERE\ve\db"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2(x64)\nginx\html\upload" "WHERE\upload"
Xcopy /y /E /I "UserDrive:\Program Files\BioStar 2(x64)\lic" "WHERE\lic"
xcopy /y "UserDrive:\Program Files\BioStar 2(x64)\nginx\conf\biostar_cert.crt" "WHERE\conf\"
xcopy /y "UserDrive:\Program Files\BioStar 2(x64)\nginx\conf\biostar_cert.key" "WHERE\conf\"
xcopy /y "UserDrive:\Program Files\BioStar 2(x64)\nginx\conf\biostar_cert.p12" "WHERE\conf\"
xcopy /y "UserDrive:\Program Files\BioStar 2(x64)\nginx\conf\keystore.jks" "WHERE\conf\"
copy /y "UserDrive:\Program Files\BioStar 2(x64)\setting.conf" "WHERE\"
copy /y "UserDrive:\Program Files\BioStar 2(x64)\system.conf" "WHERE\"
copy /y "KEYENC" "WHERE\"

echo.
echo Non-Database files Copied

:EncLocation
set ENCKEY="KEYENC"
DEL /F "WHERE\enckeyloc.txt"
echo %enckey% >> "WHERE\enckeyloc.txt"

:MOVE

Echo Moving SQL Files...

md "WHERE\" 2> nul

move /y "UserDrive:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin\ACbackup.sql" "WHERE\"

move /y "UserDrive:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin\TAbackup.sql" "WHERE\"

move /y "UserDrive:\Program Files\BioStar 2(x64)\ta\mariadb-10.1.10-winx64\bin\VEbackup.sql" "WHERE\"

Echo All Done!
timeout 6
goto END

:CHECK_FAIL
@echo off
IF %ERRORLEVEL% NEQ 0 (
echo.
Echo Wrong User or Password Detected
pause
EXIT
) 

:END
endlocal